PBKDF2KeyWithParameters (Bouncy Castle Library 1.54 API Specification)
Date: 2015-12-29

org.bouncycastle.jcajce

## Class PBKDF2KeyWithParameters

- java.lang.Object
- - org.bouncycastle.jcajce.PBKDF2Key
  - - org.bouncycastle.jcajce.PBKDF2KeyWithParameters

- All Implemented Interfaces:
    java.io.Serializable, java.security.Key, javax.crypto.interfaces.PBEKey, javax.crypto.SecretKey, PBKDFKey

      public class PBKDF2KeyWithParameters
      extends PBKDF2Key
      implements javax.crypto.interfaces.PBEKey

  A password based key for use with PBKDF2 as defined in PKCS#5 with full PBE parameters.
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from interface javax.crypto.interfaces.PBEKey

      `serialVersionUID`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PBKDF2KeyWithParameters(char[] password, CharToByteConverter converter, byte[] salt, int iterationCount)` Basic constructor for a password based key with generation parameters using FIPS PBKDF.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getIterationCount()` Return the iteration count to use in the key derivation function.
    `byte[]` | `getSalt()` Return the salt to use in the key derivation function.

    - ### Methods inherited from class org.bouncycastle.jcajce.PBKDF2Key

      `getAlgorithm, getEncoded, getFormat, getPassword`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface javax.crypto.interfaces.PBEKey

      `getPassword`

    - ### Methods inherited from interface java.security.Key

      `getAlgorithm, getEncoded, getFormat`

- - ### Constructor Detail

    - #### PBKDF2KeyWithParameters

          public PBKDF2KeyWithParameters(char[] password,
                                 CharToByteConverter converter,
                                 byte[] salt,
                                 int iterationCount)

      Basic constructor for a password based key with generation parameters using FIPS PBKDF.
      Parameters:
        `password` - password to use.
        `converter` - converter to use for transforming characters into bytes.
        `salt` - salt for generation algorithm
        `iterationCount` - iteration count for generation algorithm.

  - ### Method Detail

    - #### getSalt

          public byte[] getSalt()

      Return the salt to use in the key derivation function.
      Specified by:
        `getSalt` in interface `javax.crypto.interfaces.PBEKey`
      Returns:
        the salt to use in the KDF.

    - #### getIterationCount

          public int getIterationCount()

      Return the iteration count to use in the key derivation function.
      Specified by:
        `getIterationCount` in interface `javax.crypto.interfaces.PBEKey`
      Returns:
        the iteration count to use in the KDF.